% EJEMPLO DE CORRECCIN POR F2
% Representacin de un barrido, sin calibrar y calibrado.
% Adems, comprobamos la diferencia entre
% ambas representaciones.

clear all
clc
Datos = load('Prueba');
lambda = Datos(:,1)./10;
Ycorr = Datos(:,2);
Xcorr = Datos(:,4);

% Normalizamos ambas seales entre 0 y 1.
YcorrNorm = Ycorr/max(Ycorr);
XcorrNorm = Xcorr/max(Xcorr);

% Comprobamos diferencia entre ambas grficas
Dif = XcorrNorm-YcorrNorm;

figure(1)
hold on
grid minor
title('Representacin de Xcorr e Ycorr')
xlabel('Longitud de onda (nm)')
ylabel('Intensidad (u.a.)')
plot(lambda, Xcorr, 'r','LineWidth',1.5)
plot(lambda, Ycorr, 'b','LineWidth',1.5)

figure(2)
hold on
grid minor
title('Representacin de Xcorr e Ycorr normalizados')
xlabel('Longitud de onda (nm)')
ylabel('Intensidad (u.a.)')
plot(lambda, XcorrNorm, 'r','LineWidth',1.5)
plot(lambda, YcorrNorm, 'b','LineWidth',1.5)

% Representamos la diferencia entre ambas grficas.
% Podemos observar que la seal calibrada est por encima a longitudes
% de onda ms bajas y pasa a estar por debajo a longitudes de onda
% mayores, como era de esperar. 
% A pesar de ello, la correccin no se nota demasiado y la seal obtenida
% de la emisin del LED sigue estando deformada.
figure(3)
hold on
grid minor
title('Diferencia entre Xcorr e Ycorr')
xlabel('Longitud de onda (nm)')
ylabel('Xcorr - Ycorr (u.a.)')
plot(lambda, Dif,'LineWidth',2)
