% Fichero para la representacin de varios barridos realizados 
% para LEDs de diferentes colores. Procederemos a representar
% todos los LEDs en una misma imagen, al igual que en las hojas
% de especificaciones, para facilitar as su comparacin.
clc
clear all

% Leemos los datos del fichero de texto para el LED Verde
LEDverde = load('LEDverde');
lambdaV = LEDverde(:,1);
EspectroV = LEDverde(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(EspectroV);
maxV = lambdaV(Y);
% Normalizamos al mximo para la representacin
EspectroV = EspectroV./max(EspectroV);

% Leemos los datos del fichero de texto para el LED Amarillo
LEDamarillo2 = load('LEDamarillo2');
lambdaA2 = LEDamarillo2(:,1);
EspectroA2 = LEDamarillo2(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(EspectroA2);
maxA2 = lambdaA2(Y);
% Normalizamos al mximo para la representacin
EspectroA2 = EspectroA2./max(EspectroA2);

% Leemos los datos del fichero de texto para el LED Rojo
LEDrojo = load('LEDrojo');
lambdaR = LEDrojo(:,1);
EspectroR = LEDrojo(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(EspectroR);
maxR = lambdaR(Y);
% Normalizamos al mximo para la representacin
EspectroR = EspectroR./max(EspectroR);

figure(1)
hold on
grid on
title('Espectro de los LED verde, amarillo y rojo')
xlabel('Longitud de onda (nm)')
ylabel('Intensidad normalizada (u.a.)')
plot(lambdaA2./10,EspectroA2,'y', 'Linewidth', 2.0);
plot(lambdaV./10,EspectroV,'g', 'Linewidth', 2.0);
plot(lambdaR./10,EspectroR,'r', 'Linewidth', 2.0);

% Comprobamos el error en cuanto a la posicin del mxima obtenida mediante
% el sistema y a la posicin del mximo dada por las hojas de
% especificaciones.
HojaEspecif=[565 583 635]; Sistema=[maxV/10 maxA2/10 maxR/10]; Error=Sistema-HojaEspecif;