% MNIMOS CUADRADOS
% Ajuste del espectro de radiacin del cuerpo negro a los datos obtenidos
% por el fotodiodo.
% W = Espectro de radiacin del cuerpo negro, cada columna es para una cali.
% PD = Medida obtenida por el fotodiodo, cada columna es para una cali.
clc
clear all

% Leemos los datos del fichero de texto JesusIR096
LED1 = load('JesusIR096');
lambda1 = LED1(:,1);
Espectro1 = LED1(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(Espectro1);
max1 = lambda1(Y);
% Normalizamos al mximo para la representacin
Espectro1 = Espectro1./max(Espectro1);

% Leemos los datos del fichero de texto JesusRojo096
LED2 = load('JesusRojo096');
lambda2 = LED2(:,1);
Espectro2 = LED2(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(Espectro2);
max2 = lambda2(Y);
% Normalizamos al mximo para la representacin
Espectro2 = Espectro2./max(Espectro2);

% Leemos los datos del fichero de texto JesusIR143
LED3 = load('JesusIR143');
lambda3 = LED3(:,1);
Espectro3 = LED3(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(Espectro3);
max3 = lambda3(Y);
% Normalizamos al mximo para la representacin
Espectro3 = Espectro3./max(Espectro3);

% Leemos los datos del fichero de texto JesusRojo143
LED4 = load('JesusRojo143');
lambda4 = LED4(:,1);
Espectro4 = LED4(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(Espectro4);
max4 = lambda4(Y);
% Normalizamos al mximo para la representacin
Espectro4 = Espectro4./max(Espectro4);

% Leemos los datos del fichero de texto JesusIR154
LED5 = load('JesusIR154');
lambda5 = LED5(:,1);
Espectro5 = LED5(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(Espectro5);
max5 = lambda5(Y);
% Normalizamos al mximo para la representacin
Espectro5 = Espectro5./max(Espectro5);

% Leemos los datos del fichero de texto JesusRojo154
LED6 = load('JesusRojo154');
lambda6 = LED6(:,1);
Espectro6 = LED6(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(Espectro6);
max6 = lambda6(Y);
% Normalizamos al mximo para la representacin
Espectro6 = Espectro6./max(Espectro6);

figure(1)
hold on
grid on
title('Espectro de 3 pinzas de Jess')
xlabel('Longitud de onda (nm)')
ylabel('Intensidad normalizada (u.a.)')
plot(lambda1./10,Espectro1,'y', 'Linewidth', 2.0); %JesusIR096
plot(lambda2./10,Espectro2,'g', 'Linewidth', 2.0); %JesusRojo096
plot(lambda3./10,Espectro3,'r', 'Linewidth', 2.0); %JesusIR143
plot(lambda4./10,Espectro4,'b', 'Linewidth', 2.0); %JesusRojo143
plot(lambda5./10,Espectro5,'c', 'Linewidth', 2.0); %JesusIR154
plot(lambda6./10,Espectro6,'m', 'Linewidth', 2.0); %JesusRojo154

% AQU VAMOS A REPRESENTAR LOS UPN
% Leemos los datos del fichero de texto JesusIRUPN
LED7 = load('JesusIRUPN');
lambda7 = LED7(:,1);
Espectro7 = LED7(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(Espectro7);
max7 = lambda7(Y);
% Normalizamos al mximo para la representacin
Espectro7 = Espectro7./max(Espectro7);

% Leemos los datos del fichero de texto JesusIRUPN2
LED8 = load('JesusIRUPN2');
lambda8 = LED8(:,1);
Espectro8 = LED8(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(Espectro8);
max8 = lambda8(Y);
% Normalizamos al mximo para la representacin
Espectro8 = Espectro8./max(Espectro8);

% Leemos los datos del fichero de texto JesusRojoUPN
LED9 = load('JesusRojoUPN');
lambda9 = LED9(:,1);
Espectro9 = LED9(:,4);
% Comprobamos la posicin del mximo
[X,Y]=max(Espectro9);
max9 = lambda9(Y);
% Normalizamos al mximo para la representacin
Espectro9 = Espectro9./max(Espectro9);

figure(2)
hold on
grid on
title('Espectro de LEDs UPN de Jess')
xlabel('Longitud de onda (nm)')
ylabel('Intensidad normalizada (u.a.)')
plot(lambda7./10,Espectro7,'y', 'Linewidth', 2.0); %JesusIRUPN
plot(lambda8./10,Espectro8,'g', 'Linewidth', 2.0); %JesusIRUPN2
plot(lambda9./10,Espectro9,'r', 'Linewidth', 2.0); %JesusRojoUPN

% Comprobamos el error en cuanto a la posicin del mximo obtenida mediante
% el sistema y a la posicin del mximo dada por las hojas de
% especificaciones.
HojaEspecif=[905 660 905 660 905 660 905 905 660]; 
Sistema=[max1/10 max2/10 max3/10 max4/10 max5/10 max6/10 max7/10 max8/10 max9/10]; 
Error=Sistema-HojaEspecif;