% MNIMOS CUADRADOS
% Ajuste del espectro de radiacin del cuerpo negro a los datos obtenidos
% por el fotodiodo.
% W = Espectro de radiacin del cuerpo negro, cada columna es para una cali.
% PD = Medida obtenida por el fotodiodo, cada columna es para una cali.
clc
clear all
% Leemos los datos del fichero .txt
Datos = load('Datos.txt');
W = Datos(:,1:9);
PD = Datos(:,12:20);
lambda = [500:2:1080];
cte = [];
i = 0;
% PD*cte = W
% Calculamos cte para cada cali y lo almacenamos en un vector. Cada cali va
% a ser vlida slo en un rango, si la seal del fotodiodo est saturada o
% es nula hay que desecharlo.

% Para caliA1 empezamos en 986 nm, en los vectores columna
% de W y PD, los 986 nm equivalen a la posicin 244 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(244:256,i)'*PD(244:256,i))*PD(244:256,i)'*W(244:256,i);
% Para caliA2 empezamos en 900 nm, en los vectores columna
% de W y PD, los 900 nm equivalen a la posicin 201 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(201:256,i)'*PD(201:256,i))*PD(201:256,i)'*W(201:256,i);
% Para caliA3 empezamos en 800 nm, en los vectores columna
% de W y PD, los 800 nm equivalen a la posicin 151 del vector, entonces:
i=i+1;
cte(i) = inv(PD(151:256,i)'*PD(151:256,i))*PD(151:256,i)'*W(151:256,i);
% Para caliA4 empezamos en 780 nm, en los vectores columna
% de W y PD, los 780 nm equivalen a la posicin 141 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(141:256,i)'*PD(141:256,i))*PD(141:256,i)'*W(141:256,i);
% Para caliA5 empezamos en 700 nm, en los vectores columna
% de W y PD, los 700 nm equivalen a la posicin 101 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(101:256,i)'*PD(101:256,i))*PD(101:256,i)'*W(101:256,i);
% Para caliA6 empezamos en 700 nm, en los vectores columna
% de W y PD, los 700 nm equivalen a la posicin 101 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(101:256,i)'*PD(101:256,i))*PD(101:256,i)'*W(101:256,i);
% Para caliA7 empezamos en 630 nm, en los vectores columna
% de W y PD, los 630 nm equivalen a la posicin 66 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(66:256,i)'*PD(66:256,i))*PD(66:256,i)'*W(66:256,i);
% Para caliA8 empezamos en 590 nm, en los vectores columna
% de W y PD, los 590 nm equivalen a la posicin 46 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(46:256,i)'*PD(46:256,i))*PD(46:256,i)'*W(46:256,i);
% Para caliA9 empezamos en 580 nm, en los vectores columna
% de W y PD, los 580 nm equivalen a la posicin 41 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(41:256,i)'*PD(41:256,i))*PD(41:256,i)'*W(41:256,i);
% % Para caliA10 empezamos en 570 nm, en los vectores columna
% % de W y PD, los 570 nm equivalen a la posicin 9 del vector. Y terminamos
% % en 932 nm que equivalen a la posicin 217 del vector, entonces:
% i=i+1;
% cte(i) = inv(PD(37:196,i)'*PD(37:196,i))*PD(37:196,i)'*W(37:196,i);
% % Para caliA11 empezamos en 570 nm, en los vectores columna
% % de W y PD, los 570 nm equivalen a la posicin 9 del vector. Y terminamos
% % en 890 nm que equivalen a la posicin 196 del vector, entonces:
% i=i+1;
% cte(i) = inv(PD(37:217,i)'*PD(37:217,i))*PD(37:217,i)'*W(37:217,i);
% Ahora calculamos la media:
cte
media = mean(cte)
varianza = var(cte)
desviacionTipica = std(cte)
% Representamos W y PD sin corregir en figure(1) y corregidas en figure(2).
figure(1)
hold on
grid on
title('Espectro de la lmpara halgena junto con el del cuerpo negro a diferentes temperaturas')
xlabel('Longitud de onda (nm)')
ylabel('Intensidad (u.a.)')
plot(lambda,W,'r.-');
plot(lambda,PD*media);
for i=1:9
    figure(i+1)
    hold on
    title('Espectro de la lmpara halgena junto con el del cuerpo negro')
    xlabel('Longitud de onda (nm)')
    ylabel('Intensidad (u.a.)')
    plot(lambda,(W(:,i)),'r.');
    plot(lambda,(PD(:,i)*cte(i)));
    hold off
end