% MNIMOS CUADRADOS
% Ajuste del espectro de radiacin del cuerpo negro a los datos obtenidos
% por el fotodiodo.
% W = Espectro de radiacin del cuerpo negro, cada columna es para una cali.
% PD = Medida obtenida por el fotodiodo, cada columna es para una cali.
clc
clear all
% Leemos los datos del fichero .txt
Datos = load('Datos.txt');
W = Datos(:,2:14);  % La caliB1 no la cogemos porque es todo ruido
PD = Datos(:,16:28);
lambda = [500:2:1080];
cte = [];
i = 0;
% PD*cte = W
% Calculamos cte para cada cali y lo almacenamos en un vector. Cada cali va
% a ser vlida slo en un rango, si la seal del fotodiodo est saturada o
% es nula hay que desecharlo.

% Para caliB2 empezamos en 960 nm, en los vectores columna
% de W y PD, los 960 nm equivalen a la posicin 231 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(231:256,i)'*PD(231:256,i))*PD(231:256,i)'*W(231:256,i);
% Para caliB3 empezamos en 900 nm, en los vectores columna
% de W y PD, los 900 nm equivalen a la posicin 201 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(201:256,i)'*PD(201:256,i))*PD(201:256,i)'*W(201:256,i);
% Para caliB4 empezamos en 820 nm, en los vectores columna
% de W y PD, los 820 nm equivalen a la posicin 161 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(161:256,i)'*PD(161:256,i))*PD(161:256,i)'*W(161    :256,i);
% Para caliB5 empezamos en 766 nm, en los vectores columna
% de W y PD, los 766 nm equivalen a la posicin 134 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(134:256,i)'*PD(134:256,i))*PD(134:256,i)'*W(134:256,i);
% Para caliB6 empezamos en 720 nm, en los vectores columna
% de W y PD, los 720 nm equivalen a la posicin 111 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(111:256,i)'*PD(111:256,i))*PD(111:256,i)'*W(111:256,i);
% Para caliB7 empezamos en 700 nm, en los vectores columna
% de W y PD, los 700 nm equivalen a la posicin 101 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(101:256,i)'*PD(101:256,i))*PD(101:256,i)'*W(101:256,i);
% Para caliB8 empezamos en 690 nm, en los vectores columna
% de W y PD, los 690 nm equivalen a la posicin 96 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(96:256,i)'*PD(96:256,i))*PD(96:256,i)'*W(96:256,i);
% Para caliB9 empezamos en 716 nm, en los vectores columna
% de W y PD, los 716 nm equivalen a la posicin 109 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(109:256,i)'*PD(109:256,i))*PD(109:256,i)'*W(109:256,i);
% Para caliB10 empezamos en 680 nm, en los vectores columna
% de W y PD, los 680 nm equivalen a la posicin 91 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(91:256,i)'*PD(91:256,i))*PD(91:256,i)'*W(91:256,i);
% Para caliB11 empezamos en 580 nm, en los vectores columna
% de W y PD, los 580 nm equivalen a la posicin 41 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(41:256,i)'*PD(41:256,i))*PD(41:256,i)'*W(41:256,i);
% Para caliB12 empezamos en 560 nm, en los vectores columna
% de W y PD, los 560 nm equivalen a la posicin 31 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(31:256,i)'*PD(31:256,i))*PD(31:256,i)'*W(31:256,i);
% Para caliB13 empezamos en 560 nm, en los vectores columna
% de W y PD, los 560 nm equivalen a la posicin 31 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(31:256,i)'*PD(31:256,i))*PD(31:256,i)'*W(31:256,i);
% Para caliB14 empezamos en 566 nm, en los vectores columna
% de W y PD, los 566 nm equivalen a la posicin 34 del vector. Y terminamos
% en 1010 nm que equivalen a la posicin 256 del vector, entonces:
i=i+1;
cte(i) = inv(PD(34:256,i)'*PD(34:256,i))*PD(34:256,i)'*W(34:256,i);
% Ahora calculamos la media:
cte
media = mean(cte)
varianza = var(cte)
desviacionTipica = std(cte)
% Representamos W y PD sin corregir en figure(1) y corregidas en figure(2).
figure(1)
hold on
grid on
title('Espectro de la lmpara incandescente junto con el del cuerpo negro a diferentes temperaturas')
xlabel('Longitud de onda (nm)')
ylabel('Intensidad (u.a.)')
plot(lambda,W,'r.-');
plot(lambda,PD*media);
for i=1:13
    figure(i+1)
    hold on
    title('Espectro de la lmpara incandescente junto con el del cuerpo negro')
    xlabel('Longitud de onda (nm)')
    ylabel('Intensidad (u.a.)')
    plot(lambda,(W(:,i)),'r.');
    plot(lambda,(PD(:,i)*cte(i)));
    hold off
end