/**********************************************************
                  		Header files
 **********************************************************/
#include "lpc21xx.h"

/**********************************************************
                    	  Prototypes
 **********************************************************/
void _puts(char *);
void _printf(char *,...);
extern void (*_vputch)(int);
extern int (*_vgetch)();
//#define _putch(d) ((*_vputch)(d))
//#define _getch() ((*_vgetch)())
void _putch(char);
char _getch();
int	_gets(unsigned char *,int);
void _U0putch(unsigned char);
unsigned char _U0getch();

/**********************************************************
                 			Clocks
**********************************************************/

#define FOSC    14745600        // Crystal frequency
#define MSEL    4               // PLL multiplier
#define CCLK    (FOSC*MSEL)	    // CPU clock
#define PCKDIV  1               // APB divider
#define PCLK    (CCLK/PCKDIV)   // Peripheral clock

// delays
void _delay_loop(unsigned int);
#define _delay_us(n) _delay_loop(CCLK/4000000.0*n-1)
#define _delay_ms(n) _delay_loop(CCLK/4000.0*n-1)

/**********************************************************
		Variables globales
**********************************************************/
//int stst[4]={1,8,2,4};	// Para pasos.
int stst[8]={1,9,8,10,2,6,4,5};	// Para semipasos.
int x=0;

/**********************************************************
                       MAIN SECTION
**********************************************************/

void main(void) __attribute__ ((noreturn));

void Avanzar(int semiPasos)
{	
	int i=0, fcAlto, fcBajo;
	/*unsigned char *pw;
	pw = &w;
	_puts("\r\n\nIntroduzca nº amgstrons a avanzar: \r\n\n");
	k=_gets(pw, w);	//k = número de cifras del número introducido.
	j=1;
	for(i=0;i<k;i++)	//Bucle para obtener numAmgstrons
	{
		num = ((w&(0xFF<<(8*((k-1)-i))))>>(8*((k-1)-i)))-48;
		numAmgstrons = numAmgstrons+(num*j);
		j = j*10;
	}*/
	//_printf("\r\n\nAvanzamos %d semi-pasos\r\n\n", semiPasos);
	for(i=0;i<semiPasos;i++)
	{
		fcAlto = ((FIOPIN & 0x2000) >> 13);
		fcBajo = ((FIOPIN & 0x8000) >> 15);
		_delay_ms(1);
		// avanzar
		if (fcAlto)
		{ // comprobar final de carrera
			x=(x+1)&7;	//CUIDADO!! 3 para pasos y 7 para semipasos, si usamos el otro stst[x]
		}
		else
		{
			_puts("fcArriba\n");	//Llegamos al final de carrera por arriba.
			i=semiPasos;
		}
	
		FIOSET = (stst[x]<<4);	// Lo movemos 4 bits a la izda ya que son los bits P0.4 a P0.7
		_delay_ms(10);
		FIOCLR = 0xF0;	// Quitar potencia al motor.
	}
}

void Retroceder(int semiPasos)
{
	int i=0, fcAlto, fcBajo;
	/*unsigned char *pw;
	pw = &w;
	_puts("\r\n\nIntroduzca nº amgstrons a retroceder: \r\n\n");
	k=_gets(pw, w);	//k = número de cifras del número introducido.
	j=1;
	for(i=0;i<k;i++)	//Bucle para obtener numAmgstrons
	{
		num = ((w&(0xFF<<(8*((k-1)-i))))>>(8*((k-1)-i)))-48;
		numAmgstrons = numAmgstrons+(num*j);
		j = j*10;
	}*/
	//_printf("\r\n\nRetrocedemos %d semi-pasos\r\n\n", semiPasos);
	for(i=0;i<semiPasos;i++)
	{
		fcAlto = ((FIOPIN & 0x2000) >> 13);
		fcBajo = ((FIOPIN & 0x8000) >> 15);
		_delay_ms(1);
		// retroceder
		if (fcBajo)
		{ // comprobar final de carrera
			x=(x-1)&7;	//CUIDADO!! 3 para pasos y 7 para semipasos
		}
		else
		{
			_puts("fcBajo\n");	//Llegamos al final de carrera por abajo.
			i=semiPasos;
		}
	
		FIOSET = (stst[x]<<4);	// Lo movemos 4 bits a la izda ya que son los bits P0.4 a P0.7
		_delay_ms(10);
		FIOCLR = 0xF0;	// Quitar potencia al motor.
	}
}

void EncenderLED()
{
	//_puts("\r\n\nEncendemos LED\r\n\n");
	FIOSET = (1<<8);
	_delay_ms(50);
}

void ApagarLED()
{
	//_puts("\r\n\nApagamos LED\r\n\n");
	FIOCLR = (1<<8);
	_delay_ms(50);
}

void TomarMedida()
{
	int resultado=0;// aux=0;
	unsigned char done=0, medido=0, i=0, numMedidas=75;
	//_puts("\r\n\nTomamos medida del fotodiodo.\r\n\n");
	//_delay_ms(100);
	while(i<numMedidas)
	{
		medido=0;
		while(!medido)
		{
			done =(AD0GDR & 0x80000000) >> 31;
			if (done)	//	Comprobamos el DONE.
			{
				medido=1; 
				i++;
				//aux=(AD0GDR & 0xFFC0)>>6;
				//_printf("El resultado es = %d \r\n", aux);
				//resultado += aux;	//	Leemos el resultado.
				resultado += (AD0GDR & 0xFFC0)>>6;
				//_printf("El resultado es = %d \r\n", resultado);
				//_delay_ms(50);
			}
			//_delay_ms(50);
		}
	}
	resultado = (resultado/numMedidas);
	_printf("%d\n", resultado);
}

void EtapaAmplificadora(int opcion)
{
	//_puts("\r\n\nSeleccionar ganancia:\r\n\n");

	switch (opcion)
	{
		case 1:	// 49=1 en ASCII
			//_puts("\r\n\nGanancia seleccionada: x1\r\n\n");
			FIOCLR=0x2800000;
			FIOSET=0x0000000;	// 23 y 25 a 0 => x1
			break;
		case 2:	// 50=2 en ASCII
			//_puts("\r\n\nGanancia seleccionada: x4\r\n\n");
			FIOCLR=0x2800000;
			FIOSET=0x2000000;	// 23 a 0 y 25 a 1 => x4
			break;
		case 3:	// 51=3 en ASCII
			//_puts("\r\n\nGanancia seleccionada: x16\r\n\n");
			FIOCLR=0x2800000;
			FIOSET=0x0800000;	// 23 a 1 y 25 a 0 => x16
			break;
		case 4:	// 52=4 en ASCII
			//_puts("\r\n\nGanancia seleccionada: x64\r\n\n");
			FIOCLR=0x2800000;
			FIOSET=0x2800000;	// 23 y 25 a 1 => x64
			break;
		default:	// Aquí nunca debería entrar.
			_puts("La opcion seleccionada no es valida.\n");
			break;
	}
}


void main (void) {
	/*char fcAlto, fcBajo;
	int i, j;
	char c;
	static unsigned char buf[16];
	//int stst[8]={5,4,6,2,10,8,9,1};	// Para semipasos.
	int stst[4]={1,8,2,4};	// Para pasos.
	int ix=0,x=0;
	int resultado=0;*/
	
	int i=0, j=0, k=0, w=0, num=0, caracter=0, comand=0;
	int fcAlto, fcBajo;
	unsigned char *pw;
	pw = &w;

	//	Seleccionamos las Fast GPIO.
	SCS = 0x00000001;
	
	/*	Mirar chapter 7 de UM101161 LPC2103
	 * Seleccionamos la funcion de los pines:
	 * 	P0.0  -> TXD0	=> bit 0 a 1 y bit 1 a 0.	(Transmitter output for UART0)
	 * 	P0.1  -> RXD0	=> bit 2 a 1 y bit 3 a 0.	(Receive input for UART0)
	 * 	P0.10 -> AD0.3	=> bits 21 y 20 a 1.
	 *	P0.12 -> MAT1.0	=> bits 25 a 1 y el 24 a 0 
	 * 	Los demás puertos quedan a 0, GPIO, por defecto.
	 *	En binario queda: 0000 0010 0011 0000 0000 0000 0000 0101
	 *	En hexadecimal:		0	2	 3	  0	    0    0	  0	  5
	 * */
	PINSEL0 = 0x02300005;
	
	/*	Mirar chapter 8 de UM101161 LPC2103
	 * Seleccionamos que pines son de salida:
	 * 	P0.0 es de salida, pero no hace falta marcarlo aqui, es solo para los GPIO.
	 * 	P0.4	=> bit 4 a 1.	// Motor.
	 * 	P0.5	=> bit 5 a 1.	// Motor.
	 * 	P0.6	=> bit 6 a 1.	// Motor.
	 * 	P0.7	=> bit 7 a 1.	// Motor.
	 * 	P0.8	=> bit 8 a 1.	// LED.
	 * 	P0.23	=> bit 23 a 1.	// Etapa amplificadora.
	 * 	P0.25	=> bit 25 a 1.	// Etapa amplificadora.
	 * 	Los demás puertos quedan a 0, entradas, por defecto.
	 *	En binario queda: 0000 0010 1000 0000 0000 0001 1111 0000
	 *	En hexadecimal:	    0	2    8	   0	0    1	  F   0
	 * */
	FIODIR = 0x028001F0;

	/*	Temporizador.	
	 *	Mirar chapter 15 de UM101161 LPC2103
	 * Seleccionamos el modo de operacion del temporizador:
	 * 	T1MCR = 0x2		=>	Cuando llega a MR0 para de contar y reinicia. 
	 *	T1EMR = 0x31	=>	bit 0 a 1	=>	Para elegir MAT1.0
	 *					=>	bits 4 y 5 a 1	=>	Para que MAT1.0 realice un flanco.
	 * 	T1MR0 = xxxx	=> 	El numero hasta el que queremos que cuente.
	 * 	T1TCR = 2		=>	Reinicia.
	 *	T1TCR = 1		=>	Empieza a contar.
	 * */
	T1MCR = 0x0002;
	T1EMR = 0x0031;
	T1MR0 = 29491;	// Para tomar una medida cada 1 ms.
			// 2949120 para una medida cada 100 ms.
			// Tomando 75 medidas con intervalo de 1 ms entre medidas el resultado es bastante bueno.
	T1TCR = 2;
	T1TCR = 1; 
	/*	Mirar chapter 14 de UM101161 LPC2103
	 * Seleccionamos el modo de operacion del CAD:
	 * 	SEL	=>	AD0.3	=>	bit 3 a 1.
	 * 	CLKDIV	=> 13 (+1)	=> bits 8, 10 y 11 a 1.
	 * 	PDN	=>	CAD operational	=>	bit 21 a 1.	=> bit 5 a 1.
	 * 	START	=>	MAT1.0	=>	bits 25 y 26 a 1.
	 *	En binario queda: 0000 0110 0010 0000 0000 1101 0000 1000
	 *	En hexadecimal:	   0	6    2	  0		0    D	  0    8
	 * */
	ADCR = 0x6200D08;
	/*	El resultado lo leeremos con el registro AD0GDR:
	 *	El bit 31 contiene el DONE.
	 *	Y los bits 6:15 contienen el resultado.
	 *	if((AD0GDR & 0x80000000) >> 31);	//	Comprobamos el DONE.
	 *		resultado = (AD0GDR & 0xFFC0)>>6;	//	Leemos el resultado.
	 *	*/
	 

	// Inicialmente, el motor tiene todas sus patillas en alta.
	FIOCLR = 0xF0;	// Quitar potencia al motor.
	_delay_ms(50);
	// Damos unos pasos para controlar la posición del motor.
	x=0;
	while(i<8)
	{	
		i++;
		fcAlto = ((FIOPIN & 0x2000) >> 13);
		fcBajo = ((FIOPIN & 0x8000) >> 15);
		_delay_ms(1);
		// avanzar
		if (fcAlto)
		{ // comprobar final de carrera
			x=(x+1)&7;	//CUIDADO!! 3 para pasos y 7 para semipasos, si usamos el otro stst[x]
			//_puts("OK\n");
		}
		else
		{
			_puts("fcA\n");	//Llegamos al final de carrera por arriba.
			j=1;
			i=8;
		}
	
		FIOSET = (stst[x]<<4);	// Lo movemos 4 bits a la izda ya que son los bits P0.4 a P0.7
		_delay_ms(10);
		FIOCLR = 0xF0;	// Quitar potencia al motor.
	}
	
	if(!j)
	{
		_puts("OK\n");
	}

	while(1)
	{
		num=0;
		//_puts("\r\n\nIntroduzca comando: \r\n\n");
		k=_gets(pw, w);	//k = número de cifras del número introducido.
		j=1;
		for(i=0;i<k;i++)	//Bucle para obtener el comando.
		{
			// Cada caracter del comando viene en 8 bits.
			caracter = ((w&(0xFF<<(8*((k-1)-i))))>>(8*((k-1)-i)))-48;
			if(k>4&&((k-1)-i)>3)
				caracter+=48;	// Cuando leemos números de más de 3 cifras
						// es como que la cuarta cifra nos la pasa de ascii
						// a decimal él solo, luego tenemos que deshacer
						// la conversión que hacíamos nosotros.
			if(i==k-1)	// Los 8 bits menos significativos de w 
			{		// se corresponden con la letra del comando.
				comand = caracter;
			}
			else
			{
				num += caracter*j;
				j *= 10;
			}
		}
		// Comprobamos comando.
		switch (comand)
		{
			case 17:	// 65-48=17 => A en ASCII
				Avanzar(num);
				_puts("OK\n");
				break;
			case 34:	// 82-48=34 => R en ASCII
				Retroceder(num);
				_puts("OK\n");
				break;
			case 21:	// 69-48=21 => E en ASCII
				EncenderLED();
				_puts("OK\n");
				break;
			case 31:	// 79-48=31 => O en ASCII
				ApagarLED();
				_puts("OK\n");
				break;
			case 29:	// 77-48=29 => M en ASCII
				TomarMedida();
				break;
			case 23:	// 71-48=23 => G en ASCII
				EtapaAmplificadora(num);
				_puts("OK\n");
				break;
			default:	// Aquí nunca debería entrar.
				_puts("La opcion seleccionada no es valida.\n");
				break;
		}
	}
	
	/* asm volatile ("swi #0");

	while (1) PCON=1;		// CPU idle*/
}

